dnl $Id$
dnl config.m4 for extension kakasi

dnl Comments in this file start with the string 'dnl'.
dnl Remove where necessary. This file will not work
dnl without editing.

dnl If your extension references something external, use with:

PHP_ARG_WITH(kakasi, for kakasi support,
dnl Make sure that the comment is aligned:
[  --with-kakasi             Include kakasi support])

dnl Otherwise use enable:

dnl PHP_ARG_ENABLE(kakasi, whether to enable kakasi support,
dnl Make sure that the comment is aligned:
dnl [  --enable-kakasi           Enable kakasi support])

if test "$PHP_KAKASI" != "no"; then
  dnl Write more examples of tests here...

  dnl # --with-kakasi -> check with-path
   SEARCH_PATH="/usr/local /usr"     # you might want to change this
   SEARCH_FOR="/include/libkakasi.h"  # you most likely want to change this
   if test -r $PHP_KAKASI/; then # path given as parameter
     KAKASI_DIR=$PHP_KAKASI
   else # search default path list
     AC_MSG_CHECKING([for kakasi files in default path])
     for i in $SEARCH_PATH ; do
       if test -r $i/$SEARCH_FOR; then
         KAKASI_DIR=$i
         AC_MSG_RESULT(found in $i)
       fi
     done
   fi
  
   if test -z "$KAKASI_DIR"; then
     AC_MSG_RESULT([not found])
     AC_MSG_ERROR([Please reinstall the kakasi distribution])
   fi

  dnl # --with-kakasi -> add include path
   PHP_ADD_INCLUDE($KAKASI_DIR/include)

  dnl # --with-kakasi -> check for lib and symbol presence
   LIBNAME=kakasi # you may want to change this
   LIBSYMBOL=kakasi_do # you most likely want to change this 

   PHP_CHECK_LIBRARY($LIBNAME,$LIBSYMBOL,
   [
     PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $KAKASI_DIR/lib, KAKASI_SHARED_LIBADD)
     AC_DEFINE(HAVE_KAKASILIB,1,[ ])
   ],[
     AC_MSG_ERROR([wrong kakasi lib version or lib not found])
   ],[
     -L$KAKASI_DIR/lib -lm -ldl
   ])
  
   PHP_SUBST(KAKASI_SHARED_LIBADD)

  PHP_NEW_EXTENSION(kakasi, kakasi.c, $ext_shared)
fi
