/*
  +----------------------------------------------------------------------+
  | PHP Version 4                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2003 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 2.02 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available at through the world-wide-web at                           |
  | http://www.php.net/license/2_02.txt.                                 |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author:                                                              |
  +----------------------------------------------------------------------+

  $Id: header,v 1.10.8.1 2003/07/14 15:59:18 sniper Exp $ 
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"
#include "php_kakasi.h"

#include <libkakasi.h>

/* If you declare any globals in php_kakasi.h uncomment this:
ZEND_DECLARE_MODULE_GLOBALS(kakasi)
*/

/* True global resources - no need for thread safety here */
static int le_kakasi;
static unsigned char ONE_PARAM_BYREF[] = {1, BYREF_FORCE};

/* {{{ kakasi_functions[]
 *
 * Every user visible function must have an entry in kakasi_functions[].
 */
function_entry kakasi_functions[] = {
	PHP_FE(confirm_kakasi_compiled,	NULL)		/* For testing, remove later. */
	PHP_FE(kakasi_wakati, ONE_PARAM_BYREF)
	{NULL, NULL, NULL}	/* Must be the last line in kakasi_functions[] */
};
/* }}} */

/* {{{ kakasi_module_entry
 */
zend_module_entry kakasi_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
	STANDARD_MODULE_HEADER,
#endif
	"kakasi",
	kakasi_functions,
	PHP_MINIT(kakasi),
	PHP_MSHUTDOWN(kakasi),
	PHP_RINIT(kakasi),		/* Replace with NULL if there's nothing to do at request start */
	PHP_RSHUTDOWN(kakasi),	/* Replace with NULL if there's nothing to do at request end */
	PHP_MINFO(kakasi),
#if ZEND_MODULE_API_NO >= 20010901
	"0.1", /* Replace with version number for your extension */
#endif
	STANDARD_MODULE_PROPERTIES
};
/* }}} */

#ifdef COMPILE_DL_KAKASI
ZEND_GET_MODULE(kakasi)
#endif

/* {{{ PHP_INI
 */
/* Remove comments and fill if you need to have entries in php.ini
PHP_INI_BEGIN()
    STD_PHP_INI_ENTRY("kakasi.global_value",      "42", PHP_INI_ALL, OnUpdateInt, global_value, zend_kakasi_globals, kakasi_globals)
    STD_PHP_INI_ENTRY("kakasi.global_string", "foobar", PHP_INI_ALL, OnUpdateString, global_string, zend_kakasi_globals, kakasi_globals)
PHP_INI_END()
*/
/* }}} */

/* {{{ php_kakasi_init_globals
 */
/* Uncomment this function if you have INI entries
static void php_kakasi_init_globals(zend_kakasi_globals *kakasi_globals)
{
	kakasi_globals->global_value = 0;
	kakasi_globals->global_string = NULL;
}
*/
/* }}} */

/* {{{ PHP_MINIT_FUNCTION
 */
PHP_MINIT_FUNCTION(kakasi)
{
	/* If you have INI entries, uncomment these lines 
	ZEND_INIT_MODULE_GLOBALS(kakasi, php_kakasi_init_globals, NULL);
	REGISTER_INI_ENTRIES();
	*/
	return SUCCESS;
}
/* }}} */

/* {{{ PHP_MSHUTDOWN_FUNCTION
 */
PHP_MSHUTDOWN_FUNCTION(kakasi)
{
	/* uncomment this line if you have INI entries
	UNREGISTER_INI_ENTRIES();
	*/
	return SUCCESS;
}
/* }}} */

/* Remove if there's nothing to do at request start */
/* {{{ PHP_RINIT_FUNCTION
 */
PHP_RINIT_FUNCTION(kakasi)
{
	return SUCCESS;
}
/* }}} */

/* Remove if there's nothing to do at request end */
/* {{{ PHP_RSHUTDOWN_FUNCTION
 */
PHP_RSHUTDOWN_FUNCTION(kakasi)
{
	return SUCCESS;
}
/* }}} */

/* {{{ PHP_MINFO_FUNCTION
 */
PHP_MINFO_FUNCTION(kakasi)
{
	php_info_print_table_start();
	php_info_print_table_header(2, "kakasi support", "enabled");
	php_info_print_table_end();

	/* Remove comments if you have entries in php.ini
	DISPLAY_INI_ENTRIES();
	*/
}
/* }}} */


/* Remove the following function when you have succesfully modified config.m4
   so that your module can be compiled into PHP, it exists only for testing
   purposes. */

/* Every user-visible function in PHP should document itself in the source */
/* {{{ proto string confirm_kakasi_compiled(string arg)
   Return a string to confirm that the module is compiled in */
PHP_FUNCTION(confirm_kakasi_compiled)
{
	char *arg = NULL;
	int arg_len, len;
	char string[256];

	if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &arg, &arg_len) == FAILURE) {
		return;
	}

	len = sprintf(string, "Congratulations! You have successfully modified ext/%.78s/config.m4. Module %.78s is now compiled into PHP.", "kakasi", arg);
	RETURN_STRINGL(string, len, 1);
}
/* }}} */
/* The previous line is meant for vim and emacs, so it can correctly fold and 
   unfold functions in source code. See the corresponding marks just before 
   function definition, where the functions purpose is also documented. Please 
   follow this convention for the convenience of others editing your code.
*/


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */

PHP_FUNCTION(kakasi_wakati)
{
	char *srcStr, *dstStr;
	char buffer[256];
	int strLen;
	char *argv[] = { "kakasi", "-w", "-i" , "euc", "-o", "euc" };
	int ret;

	if(ZEND_NUM_ARGS() != 1)
	{
		//strLen = sprintf(buffer, "ZEND_NUM_ARGS() == %d", ZEND_NUM_ARGS());
		//RETURN_STRINGL(buffer, strLen, 1);
		WRONG_PARAM_COUNT;
		return;
	}

	if(zend_parse_parameters(ZEND_NUM_ARGS(), TSRMLS_CC "s", &srcStr, &strLen) == FAILURE)
	{
		//strLen = sprintf(buffer, "zend_parse_parameters() == FAILURE");
		//RETURN_STRINGL(buffer, strLen, 1);
		WRONG_PARAM_COUNT;
		return;
	}

	ret = kakasi_getopt_argv(6, argv);
	if(ret == 0)
	{
		dstStr = kakasi_do(srcStr);
		if(dstStr)
		{
			//ZVAL_STRINGL(return_value, dstStr, strLen, 1);
			RETURN_STRING(dstStr, 1);
			kakasi_free(dstStr);
			dstStr = NULL;
		}
		else
		{
			php_error(E_ERROR, "Couldn't execute kakasi.");
		}
	}
	else
	{
		php_error(E_ERROR, "Couldn't execute kakasi.");
	}

	kakasi_close_kanwadict();
}

